import java.io.*;
import java.util.*;
import java.awt.*;
import java.lang.*;
import javax.swing.*;

public class DisplayableBinaryTree
{
	BinaryTree t;
	int windowWidth, windowHeight;
	int widths[], heights[],pos=0;
	String letters = new String();
	
	public DisplayableBinaryTree (BinaryTree t, int windowWidth, int windowHeight)
	{
		this.t = t;
		this.windowWidth = windowWidth;
		this.windowHeight = windowHeight;
	}
	
	public String inOrder()
	{
		return t.inOrder();	
	}
	
	public void display()
	{
		String BinaryTreeString = new String();
		String InOrderString = new String();
		JFrame TreeDisp = new JFrame("TreeDisplayWindow");
		TreeDisp.show();
		TreeDisp.validate();
		TreeDisp.setDefaultCloseOperation(TreeDisp.EXIT_ON_CLOSE);
		Graphics g = TreeDisp.getGraphics();
		int instring=0, ypos=0, xpos=0, height=0, width=0;
		TreeDisp.setSize(windowWidth, windowHeight);
		InOrderString = t.inOrder();
		width=InOrderString.length();
		BinaryTreeString = t.CustomOrder();
		height=t.height()+1;
		windowHeight-=48;
		windowWidth-=8;
		widths=new int[width];
		heights=new int[width];
		
		while(instring!=BinaryTreeString.length())
		{
			if(BinaryTreeString.charAt(instring+1)>='0' && BinaryTreeString.charAt(instring+1)<='9')
			{
				ypos=Integer.parseInt(BinaryTreeString.substring(instring, instring+2));
				instring=instring+2;
			}		
			else
			{
				ypos=Integer.parseInt(BinaryTreeString.substring(instring, instring+1));
				instring=instring+1;
			}
			widths[pos]=xpos*(windowWidth/width)+30;
			heights[pos]=ypos*(windowHeight/height)+30;
			pos++;
			letters = letters.concat(BinaryTreeString.substring(instring, instring+1));
			instring++;
			xpos++;
		}
		for(int i=0;i<width;i++)
		{
			DisplayNode(g, letters.substring(i,i+1), widths[i], heights[i]);
		}
		printlines(g, t.ReturnRoot());
	}
	
	public void printlines(Graphics g, BinaryNode OriginNode)
	{
		String MeString;
		int pos1,pos2,slantx,slanty;
		pos1=letters.indexOf((String)OriginNode.getElement());
		if(OriginNode.getLeft()!=null)
		{
			pos2=letters.indexOf((String)OriginNode.getLeft().getElement());
			g.drawLine(widths[pos1]+12,heights[pos1]+25,widths[pos2]+12,heights[pos2]);
			slanty=(heights[pos1]+25-heights[pos2]);
			slantx=(widths[pos1]-widths[pos2]);
			g.drawLine(widths[pos2]+12,heights[pos2],widths[pos2]+12+slantx/10+3,heights[pos2]+slanty/10+3); //i take a real bad approach to drawing the slants for the lines
			g.drawLine(widths[pos2]+12,heights[pos2],widths[pos2]+12+slantx/10-3,heights[pos2]+slanty/10-3); //but i'm sure theres a way to have java do it automatically i'm just not sure about
			printlines(g, OriginNode.getLeft());
		}
		if(OriginNode.getRight()!=null)
		{
			pos2=letters.indexOf((String)OriginNode.getRight().getElement());
			g.drawLine(widths[pos1]+12,heights[pos1]+25,widths[pos2]+12,heights[pos2]);
			slanty=(heights[pos1]+25-heights[pos2]);
			slantx=(widths[pos1]-widths[pos2]);
			g.drawLine(widths[pos2]+12,heights[pos2],widths[pos2]+12+slantx/10+3,heights[pos2]+slanty/10-3);
			g.drawLine(widths[pos2]+12,heights[pos2],widths[pos2]+12+slantx/10-3,heights[pos2]+slanty/10+3);
			printlines(g, OriginNode.getRight());
		}		
	}
	
	public void DisplayNode(Graphics g, String s, int XPos, int YPos)
	{
		Font customfont = g.getFont();
		customfont = new Font(customfont.getFontName(),customfont.getStyle(),13);
		g.setFont(customfont);
		g.drawOval(XPos,YPos,25,25);
		g.drawString(s,XPos+8,YPos+18);
	}
	
}