import java.io.*;

public class TextFillPrintStream extends PrintStream
{
	private PrintStream out;
	private int CurrentLength;
	private int MaxLengthGlobal;
	
	public TextFillPrintStream(int MaxLength, PrintStream _out)
    {
      super(_out);
      out=_out;
      MaxLengthGlobal=MaxLength;
    }
    
	public void print(String s)
	{
		if(CurrentLength==0)
			out.print(s);
		else if(CurrentLength+s.length() > MaxLengthGlobal)
		{
			out.print("\n"+s);
			CurrentLength=0;
		}
		else
			out.print(s);
		
		CurrentLength+=s.length();
	}
}