// Jeffrey Riaboy
//java TestThreadedTree H F G B C A J E D M I K L
//java TestThreadedTree now is the time for all good men to come to the aid of their country


public class ThreadedBinarySearchTree {

  ThreadedBinaryNode root;  // This is the only instance variable; do not add others.

  public void insert(Comparable x) throws ItemNotFoundException {	
  	if(root==null)
    {
    	root=new ThreadedBinaryNode(x);
    	root.isLeftThread=true;
    	root.isRightThread=true;
	}
	else
  	  insert(x, root);
  }
  
  private void insert(Comparable x, ThreadedBinaryNode t) throws DuplicateItemException {
  // insert a node containing x into its proper position in the tree
  // no balancing required.  Update left and right thread information properly.
  
    // You fill in the details.
    ThreadedBinaryNode hold;
	if(t.element.compareTo(x)==0)
		throw new DuplicateItemException(x + " is a duplicate.");
	else if (t.element.compareTo(x)>0)
	{
		if(t.isLeftThread==false)
			insert(x,t.left);
		else
		{
			hold=new ThreadedBinaryNode(x);
			hold.left=t.left;
			t.left=hold;
			hold.right=t;
			hold.isLeftThread=true;
			hold.isRightThread=true;
			t.isLeftThread=false;
		}
	}
	else if (t.element.compareTo(x)<0)
	{
		if(t.isRightThread==false)
			insert(x,t.right);
		else
		{
			hold=new ThreadedBinaryNode(x);
			hold.right=t.right;
			hold.left=t;
			t.right=hold;
			hold.isLeftThread=true;
			hold.isRightThread=true;
			t.isRightThread=false;
		}
	}
  }

  

  // Print in inorder (forward and backwards) without using a stack, 
  // recursion or extra storage space for more than a constant number
  // of node contents.

  public void printTree()   {
    
    ThreadedBinaryNode t = root;
    if (t == null)
      return;
      
    System.out.println("\nFORWARD:");
	while (!t.isLeftThread)
        t = t.left;
	while(t!=null)
	{ 
		System.out.println(t.toString());
		if(t.isRightThread)
			t=t.right;
		else
		{
			t=t.right;
			while (t.isLeftThread==false)
	        	t = t.left;	
		}
	}

    System.out.println("\n\nBACKWARD:");
    
    t = root;
	while (!t.isRightThread)
        t = t.right;
	while(t!=null)
	{
		System.out.println(t.toString());
		if(t.isLeftThread)
			t=t.left;
		else
		{
			t=t.left;
			while (t.isRightThread==false)
	        	t = t.right;	
		}
	}
    	

    // You fill in the rest of the details.
  }



// You don't really need to do anything with the following code.
// It is simply here to give you some insight into working with
// threaded binary trees.

  public Comparable find(Comparable x) throws ItemNotFoundException  {
    if (root == null)
      throw new ItemNotFoundException("Empty Tree");
    else
      return find (x, root);
  }

  private Comparable find(Comparable x, ThreadedBinaryNode t)
    throws ItemNotFoundException   {
    if (x.compareTo(t.element) < 0)
      if(t.isLeftThread)
        throw new ItemNotFoundException("Item " + x + "  not found");
      else
        return find(x, t.left);
    else if (x.compareTo(t.element) > 0)
      if(t.isRightThread)
        throw new ItemNotFoundException("Item " + x + " not found");
      else
        return find(x, t.right);
    else
      return t.element;
  }


}

  
